﻿using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Problems.ProgramSynthesis;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace HeuristicLab.Tests.Interpreter.Expressions {
  [TestClass]
  public class FloatVectorExpressionTests : VectorExpressionTests<double> {
    protected override string TypeName { get { return "FLOAT[]"; } }

    protected override IPushStack<IReadOnlyList<double>> Stack { get { return interpreter.FloatVectorStack; } }
    protected override IPushStack<double> LiteralStack { get { return interpreter.FloatStack; } }

    protected override IReadOnlyList<double>[] GetValues(int count) {
      return Enumerable
        .Range(0, count)
        .Select(x => GetLiterals(interpreter.Configuration.MaxVectorLength / 2 - 1))
        .ToArray();
    }

    protected override IReadOnlyList<double> GetLiterals(int count) {
      return Enumerable
        .Range(0, count)
        .Select(x => interpreter.Configuration.ErcOptions.FloatErcOptions.GetErcValue(interpreter.Random))
        .ToArray();
    }

    protected override void CheckOtherStacksAreEmpty() {
      TestStackCounts(floatVectorStack: null);
    }
  }
}
